]> git.ipfire.org Git - people/ms/u-boot.git/blob - MAKEALL
integratorap: remove hardcoded 32MB memory cmdline
[people/ms/u-boot.git] / MAKEALL
1 #!/bin/bash
2 # Tool mainly for U-Boot Quality Assurance: build one or more board
3 # configurations with minimal verbosity, showing only warnings and
4 # errors.
5
6 usage()
7 {
8 # if exiting with 0, write to stdout, else write to stderr
9 local ret=${1:-0}
10 [ "${ret}" -eq 1 ] && exec 1>&2
11 cat <<-EOF
12 Usage: MAKEALL [options] [--] [boards-to-build]
13
14 Options:
15 -a ARCH, --arch ARCH Build all boards with arch ARCH
16 -c CPU, --cpu CPU Build all boards with cpu CPU
17 -v VENDOR, --vendor VENDOR Build all boards with vendor VENDOR
18 -s SOC, --soc SOC Build all boards with soc SOC
19 -h, --help This help output
20
21 Selections by these options are logically ANDed; if the same option
22 is used repeatedly, such selections are ORed. So "-v FOO -v BAR"
23 will select all configurations where the vendor is either FOO or
24 BAR. Any additional arguments specified on the command line are
25 always build additionally. See the boards.cfg file for more info.
26
27 If no boards are specified, then the default is "powerpc".
28
29 Environment variables:
30 BUILD_NCPUS number of parallel make jobs (default: auto)
31 CROSS_COMPILE cross-compiler toolchain prefix (default: "")
32 MAKEALL_LOGDIR output all logs to here (default: ./LOG/)
33 BUILD_DIR output build directory (default: ./)
34
35 Examples:
36 - build all Power Architecture boards:
37 MAKEALL -a powerpc
38 MAKEALL --arch powerpc
39 MAKEALL powerpc
40 - build all PowerPC boards manufactured by vendor "esd":
41 MAKEALL -a powerpc -v esd
42 - build all PowerPC boards manufactured either by "keymile" or "siemens":
43 MAKEALL -a powerpc -v keymile -v siemens
44 - build all Freescale boards with MPC83xx CPUs, plus all 4xx boards:
45 MAKEALL -c mpc83xx -v freescale 4xx
46 EOF
47 exit ${ret}
48 }
49
50 SHORT_OPTS="ha:c:v:s:"
51 LONG_OPTS="help,arch:,cpu:,vendor:,soc:"
52
53 # Option processing based on util-linux-2.13/getopt-parse.bash
54
55 # Note that we use `"$@"' to let each command-line parameter expand to a
56 # separate word. The quotes around `$@' are essential!
57 # We need TEMP as the `eval set --' would nuke the return value of
58 # getopt.
59 TEMP=`getopt -o ${SHORT_OPTS} --long ${LONG_OPTS} \
60 -n 'MAKEALL' -- "$@"`
61
62 [ $? != 0 ] && usage 1
63
64 # Note the quotes around `$TEMP': they are essential!
65 eval set -- "$TEMP"
66
67 SELECTED=''
68
69 while true ; do
70 case "$1" in
71 -a|--arch)
72 # echo "Option ARCH: argument \`$2'"
73 if [ "$opt_a" ] ; then
74 opt_a="${opt_a%)} || \$2 == \"$2\")"
75 else
76 opt_a="(\$2 == \"$2\")"
77 fi
78 SELECTED='y'
79 shift 2 ;;
80 -c|--cpu)
81 # echo "Option CPU: argument \`$2'"
82 if [ "$opt_c" ] ; then
83 opt_c="${opt_c%)} || \$3 == \"$2\")"
84 else
85 opt_c="(\$3 == \"$2\")"
86 fi
87 SELECTED='y'
88 shift 2 ;;
89 -s|--soc)
90 # echo "Option SoC: argument \`$2'"
91 if [ "$opt_s" ] ; then
92 opt_s="${opt_s%)} || \$6 == \"$2\")"
93 else
94 opt_s="(\$6 == \"$2\")"
95 fi
96 SELECTED='y'
97 shift 2 ;;
98 -v|--vendor)
99 # echo "Option VENDOR: argument \`$2'"
100 if [ "$opt_v" ] ; then
101 opt_v="${opt_v%)} || \$5 == \"$2\")"
102 else
103 opt_v="(\$5 == \"$2\")"
104 fi
105 SELECTED='y'
106 shift 2 ;;
107 -h|--help)
108 usage ;;
109 --)
110 shift ; break ;;
111 *)
112 echo "Internal error!" >&2 ; exit 1 ;;
113 esac
114 done
115 # echo "Remaining arguments:"
116 # for arg do echo '--> '"\`$arg'" ; done
117
118 FILTER="\$1 !~ /^#/"
119 [ "$opt_a" ] && FILTER="${FILTER} && $opt_a"
120 [ "$opt_c" ] && FILTER="${FILTER} && $opt_c"
121 [ "$opt_s" ] && FILTER="${FILTER} && $opt_s"
122 [ "$opt_v" ] && FILTER="${FILTER} && $opt_v"
123
124 if [ "$SELECTED" ] ; then
125 SELECTED=$(awk '('"$FILTER"') { print $1 }' boards.cfg)
126
127 # Make sure some boards from boards.cfg are actually found
128 if [ -z "$SELECTED" ] ; then
129 echo "Error: No boards selected, invalid arguments"
130 exit 1
131 fi
132 fi
133
134 #########################################################################
135
136 # Print statistics when we exit
137 trap exit 1 2 3 15
138 trap print_stats 0
139
140 # Determine number of CPU cores if no default was set
141 : ${BUILD_NCPUS:="`getconf _NPROCESSORS_ONLN`"}
142
143 if [ "$BUILD_NCPUS" -gt 1 ]
144 then
145 JOBS="-j $((BUILD_NCPUS + 1))"
146 else
147 JOBS=""
148 fi
149
150
151 if [ "${CROSS_COMPILE}" ] ; then
152 MAKE="make CROSS_COMPILE=${CROSS_COMPILE}"
153 else
154 MAKE=make
155 fi
156
157 if [ "${MAKEALL_LOGDIR}" ] ; then
158 LOG_DIR=${MAKEALL_LOGDIR}
159 else
160 LOG_DIR="LOG"
161 fi
162
163 if [ ! "${BUILD_DIR}" ] ; then
164 BUILD_DIR="."
165 fi
166
167 [ -d ${LOG_DIR} ] || mkdir ${LOG_DIR} || exit 1
168
169 LIST=""
170
171 # Keep track of the number of builds and errors
172 ERR_CNT=0
173 ERR_LIST=""
174 TOTAL_CNT=0
175 RC=0
176
177 # Helper funcs for parsing boards.cfg
178 boards_by_field()
179 {
180 awk \
181 -v field="$1" \
182 -v select="$2" \
183 '($1 !~ /^#/ && $field == select) { print $1 }' \
184 boards.cfg
185 }
186 boards_by_arch() { boards_by_field 2 "$@" ; }
187 boards_by_cpu() { boards_by_field 3 "$@" ; }
188 boards_by_soc() { boards_by_field 6 "$@" ; }
189
190 #########################################################################
191 ## MPC5xx Systems
192 #########################################################################
193
194 LIST_5xx="$(boards_by_cpu mpc5xx)"
195
196 #########################################################################
197 ## MPC5xxx Systems
198 #########################################################################
199
200 LIST_5xxx="$(boards_by_cpu mpc5xxx)"
201
202 #########################################################################
203 ## MPC512x Systems
204 #########################################################################
205
206 LIST_512x="$(boards_by_cpu mpc512x)"
207
208 #########################################################################
209 ## MPC8xx Systems
210 #########################################################################
211
212 LIST_8xx="$(boards_by_cpu mpc8xx)"
213
214 #########################################################################
215 ## PPC4xx Systems
216 #########################################################################
217
218 LIST_4xx="$(boards_by_cpu ppc4xx)"
219
220 #########################################################################
221 ## MPC8220 Systems
222 #########################################################################
223
224 LIST_8220="$(boards_by_cpu mpc8220)"
225
226 #########################################################################
227 ## MPC824x Systems
228 #########################################################################
229
230 LIST_824x="$(boards_by_cpu mpc824x)"
231
232 #########################################################################
233 ## MPC8260 Systems (includes 8250, 8255 etc.)
234 #########################################################################
235
236 LIST_8260="$(boards_by_cpu mpc8260)"
237
238 #########################################################################
239 ## MPC83xx Systems (includes 8349, etc.)
240 #########################################################################
241
242 LIST_83xx="$(boards_by_cpu mpc83xx)"
243
244 #########################################################################
245 ## MPC85xx Systems (includes 8540, 8560 etc.)
246 #########################################################################
247
248 LIST_85xx="$(boards_by_cpu mpc85xx)"
249
250 #########################################################################
251 ## MPC86xx Systems
252 #########################################################################
253
254 LIST_86xx="$(boards_by_cpu mpc86xx)"
255
256 #########################################################################
257 ## 74xx/7xx Systems
258 #########################################################################
259
260 LIST_74xx_7xx="$(boards_by_cpu 74xx_7xx)"
261
262 #########################################################################
263 ## PowerPC groups
264 #########################################################################
265
266 LIST_TSEC=" \
267 ${LIST_83xx} \
268 ${LIST_85xx} \
269 ${LIST_86xx} \
270 "
271
272 LIST_powerpc=" \
273 ${LIST_5xx} \
274 ${LIST_512x} \
275 ${LIST_5xxx} \
276 ${LIST_8xx} \
277 ${LIST_8220} \
278 ${LIST_824x} \
279 ${LIST_8260} \
280 ${LIST_83xx} \
281 ${LIST_85xx} \
282 ${LIST_86xx} \
283 ${LIST_4xx} \
284 ${LIST_74xx_7xx}\
285 "
286
287 # Alias "ppc" -> "powerpc" to not break compatibility with older scripts
288 # still using "ppc" instead of "powerpc"
289 LIST_ppc=" \
290 ${LIST_powerpc} \
291 "
292
293 #########################################################################
294 ## StrongARM Systems
295 #########################################################################
296
297 LIST_SA="$(boards_by_cpu sa1100)"
298
299 #########################################################################
300 ## ARM7 Systems
301 #########################################################################
302
303 LIST_ARM7=" \
304 ap7 \
305 ap720t \
306 armadillo \
307 B2 \
308 ep7312 \
309 evb4510 \
310 impa7 \
311 integratorap \
312 lpc2292sodimm \
313 modnet50 \
314 SMN42 \
315 "
316
317 #########################################################################
318 ## ARM9 Systems
319 #########################################################################
320
321 LIST_ARM9=" \
322 a320evb \
323 ap920t \
324 ap922_XA10 \
325 ap926ejs \
326 ap946es \
327 ap966 \
328 aspenite \
329 cp920t \
330 cp922_XA10 \
331 cp926ejs \
332 cp946es \
333 cp966 \
334 da830evm \
335 da850evm \
336 edb9301 \
337 edb9302 \
338 edb9302a \
339 edb9307 \
340 edb9307a \
341 edb9312 \
342 edb9315 \
343 edb9315a \
344 edminiv2 \
345 guruplug \
346 imx27lite \
347 jadecpu \
348 km_kirkwood \
349 lpd7a400 \
350 magnesium \
351 mv88f6281gtw_ge \
352 mx1ads \
353 mx1fs2 \
354 netstar \
355 nhk8815 \
356 nhk8815_onenand \
357 omap1510inn \
358 omap1610h2 \
359 omap1610inn \
360 omap5912osk \
361 omap730p2 \
362 openrd_base \
363 openrd_client \
364 openrd_ultimate \
365 portl2 \
366 rd6281a \
367 sbc2410x \
368 scb9328 \
369 sheevaplug \
370 smdk2400 \
371 smdk2410 \
372 spear300 \
373 spear310 \
374 spear320 \
375 spear600 \
376 VCMA9 \
377 versatile \
378 versatileab \
379 versatilepb \
380 voiceblue \
381 davinci_dvevm \
382 davinci_schmoogie \
383 davinci_sffsdr \
384 davinci_sonata \
385 davinci_dm355evm \
386 davinci_dm355leopard \
387 davinci_dm365evm \
388 davinci_dm6467evm \
389 "
390
391 #########################################################################
392 ## ARM10 Systems
393 #########################################################################
394 LIST_ARM10=" \
395 integratorcp \
396 cp1026 \
397 "
398
399 #########################################################################
400 ## ARM11 Systems
401 #########################################################################
402 LIST_ARM11=" \
403 cp1136 \
404 omap2420h4 \
405 apollon \
406 imx31_litekit \
407 imx31_phycore \
408 imx31_phycore_eet \
409 mx31ads \
410 mx31pdk \
411 mx31pdk_nand \
412 qong \
413 smdk6400 \
414 tnetv107x_evm \
415 "
416
417 #########################################################################
418 ## ARMV7 Systems
419 #########################################################################
420
421 LIST_ARMV7="$(boards_by_cpu armv7)"
422
423 #########################################################################
424 ## AT91 Systems
425 #########################################################################
426
427 LIST_at91="$(boards_by_soc at91)"
428
429 #########################################################################
430 ## Xscale Systems
431 #########################################################################
432
433 LIST_pxa="$(boards_by_cpu pxa)"
434
435 LIST_ixp="$(boards_by_cpu ixp)
436 pdnb3 \
437 scpu \
438 "
439
440 #########################################################################
441 ## ARM groups
442 #########################################################################
443
444 LIST_arm=" \
445 ${LIST_SA} \
446 ${LIST_ARM7} \
447 ${LIST_ARM9} \
448 ${LIST_ARM10} \
449 ${LIST_ARM11} \
450 ${LIST_ARMV7} \
451 ${LIST_at91} \
452 ${LIST_pxa} \
453 ${LIST_ixp} \
454 "
455
456 #########################################################################
457 ## MIPS Systems (default = big endian)
458 #########################################################################
459
460 LIST_mips4kc=" \
461 incaip \
462 qemu_mips \
463 vct_platinum \
464 vct_platinum_small \
465 vct_platinum_onenand \
466 vct_platinum_onenand_small \
467 vct_platinumavc \
468 vct_platinumavc_small \
469 vct_platinumavc_onenand \
470 vct_platinumavc_onenand_small \
471 vct_premium \
472 vct_premium_small \
473 vct_premium_onenand \
474 vct_premium_onenand_small \
475 "
476
477 LIST_mips5kc=""
478
479 LIST_au1xx0=" \
480 dbau1000 \
481 dbau1100 \
482 dbau1500 \
483 dbau1550 \
484 dbau1550_el \
485 gth2 \
486 "
487
488 LIST_mips=" \
489 ${LIST_mips4kc} \
490 ${LIST_mips5kc} \
491 ${LIST_au1xx0} \
492 "
493
494 #########################################################################
495 ## MIPS Systems (little endian)
496 #########################################################################
497
498 LIST_mips4kc_el=""
499
500 LIST_mips5kc_el=""
501
502 LIST_au1xx0_el=" \
503 dbau1550_el \
504 pb1000 \
505 "
506
507 LIST_mips_el=" \
508 ${LIST_mips4kc_el} \
509 ${LIST_mips5kc_el} \
510 ${LIST_au1xx0_el} \
511 "
512
513 #########################################################################
514 ## x86 Systems
515 #########################################################################
516
517 LIST_x86="$(boards_by_arch x86)"
518
519 #########################################################################
520 ## Nios-II Systems
521 #########################################################################
522
523 LIST_nios2="$(boards_by_arch nios2)"
524
525 #########################################################################
526 ## MicroBlaze Systems
527 #########################################################################
528
529 LIST_microblaze="$(boards_by_arch microblaze)"
530
531 #########################################################################
532 ## ColdFire Systems
533 #########################################################################
534
535 LIST_coldfire="$(boards_by_arch m68k)
536 astro_mcf5373l \
537 cobra5272 \
538 EB+MCF-EV123 \
539 EB+MCF-EV123_internal \
540 M52277EVB \
541 M5235EVB \
542 M5329AFEE \
543 M5373EVB \
544 M54451EVB \
545 M54455EVB \
546 M5475AFE \
547 M5485AFE \
548 "
549
550 #########################################################################
551 ## AVR32 Systems
552 #########################################################################
553
554 LIST_avr32="$(boards_by_arch avr32)"
555
556 #########################################################################
557 ## Blackfin Systems
558 #########################################################################
559
560 LIST_blackfin="$(boards_by_arch blackfin)"
561
562 #########################################################################
563 ## SH Systems
564 #########################################################################
565
566 LIST_sh2="$(boards_by_cpu sh2)"
567 LIST_sh3="$(boards_by_cpu sh3)"
568 LIST_sh4="$(boards_by_cpu sh4)"
569
570 LIST_sh="$(boards_by_arch sh)"
571
572 #########################################################################
573 ## SPARC Systems
574 #########################################################################
575
576 LIST_sparc="$(boards_by_arch sparc)"
577
578 #-----------------------------------------------------------------------
579
580 build_target() {
581 target=$1
582
583 ${MAKE} distclean >/dev/null
584 ${MAKE} -s ${target}_config
585
586 ${MAKE} ${JOBS} all 2>&1 >${LOG_DIR}/$target.MAKELOG \
587 | tee ${LOG_DIR}/$target.ERR
588
589 # Check for 'make' errors
590 if [ ${PIPESTATUS[0]} -ne 0 ] ; then
591 RC=1
592 fi
593
594 if [ -s ${LOG_DIR}/$target.ERR ] ; then
595 ERR_CNT=$((ERR_CNT + 1))
596 ERR_LIST="${ERR_LIST} $target"
597 else
598 rm ${LOG_DIR}/$target.ERR
599 fi
600
601 TOTAL_CNT=$((TOTAL_CNT + 1))
602
603 ${CROSS_COMPILE}size ${BUILD_DIR}/u-boot \
604 | tee -a ${LOG_DIR}/$target.MAKELOG
605 }
606 build_targets() {
607 for t in "$@" ; do
608 # If a LIST_xxx var exists, use it. But avoid variable
609 # expansion in the eval when a board name contains certain
610 # characters that the shell interprets.
611 case ${t} in
612 *[-+=]*) list= ;;
613 *) list=$(eval echo '${LIST_'$t'}') ;;
614 esac
615 if [ -n "${list}" ] ; then
616 build_targets ${list}
617 else
618 build_target ${t}
619 fi
620 done
621 }
622
623 #-----------------------------------------------------------------------
624
625 print_stats() {
626 echo ""
627 echo "--------------------- SUMMARY ----------------------------"
628 echo "Boards compiled: ${TOTAL_CNT}"
629 if [ ${ERR_CNT} -gt 0 ] ; then
630 echo "Boards with warnings or errors: ${ERR_CNT} (${ERR_LIST} )"
631 fi
632 echo "----------------------------------------------------------"
633
634 exit $RC
635 }
636
637 #-----------------------------------------------------------------------
638
639 # Build target groups selected by options, plus any command line args
640 set -- ${SELECTED} "$@"
641 # run PowerPC by default
642 [ $# = 0 ] && set -- powerpc
643 build_targets "$@"